package compare

import "testing"

var six = 6
var five = 5

var hello = "hello"
var world = "world"

// TestPointerValuesChanges validates PointerValuesChanges functionality
func TestPointerValuesChanges(t *testing.T) {

	var tests = []struct {
		Old      interface{}
		New      interface{}
		Expected bool
	}{
		{
			Old:      nil,
			New:      &six,
			Expected: true,
		},
		{
			Old:      &six,
			New:      &six,
			Expected: false,
		},
		{
			Old:      &five,
			New:      &six,
			Expected: true,
		},
		{
			Old:      &hello,
			New:      &world,
			Expected: true,
		},
		{
			Old:      &hello,
			New:      nil,
			Expected: false,
		},
		{
			Old:      &world,
			New:      &world,
			Expected: false,
		},
	}

	for _, test := range tests {
		if result := PointerValuesChanged(test.Old, test.New); result != test.Expected {
			t.Errorf("Expected %v when comparing %v and %v, got %v", test.Expected, test.Old, test.New, result)
		}
	}
}
